      SUBROUTINE QAA0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = X(I) + Y(I) + Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QAM0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = ( X(I) + Y(I) ) * Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QAM1(W,X,Y,C,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = ( X(I) + Y(I) ) * C
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QAM2(W,X,C,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = ( X(I) + C ) * Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMA0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I) + Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMA1(W,X,Y,C,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I) + C
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMA2(W,X,C,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) * C + Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMA5(W,C,X,S,N)
      SAVE
      DIMENSION W(1),X(1)
      DO 100 I=1,N
        W(I) = C * X(I) + S
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMM0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I) * Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMM1(W,X,Y,C,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I) * C
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QMS0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I) - Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QSA0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = X(I) - Y(I) + Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QSM0(W,X,Y,Z,N)
      SAVE
      DIMENSION W(1),X(1),Y(1),Z(1)
      DO 100 I=1,N
        W(I) = ( X(I) - Y(I) ) * Z(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QSM1(W,X,Y,C,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = ( X(I) - Y(I) ) * C
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVADD0(W,X,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) + Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVADD1(W,X,C,N)
      SAVE
      DIMENSION W(1),X(1)
      DO 100 I=1,N
        W(I) = X(I) + C
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVDIV0(W,X,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) / Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVDIV2(W,C,X,N)
      SAVE
      DIMENSION W(1),X(1)
      DO 100 I=1,N
        W(I) = C / X(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVMPY0(W,X,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) * Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVMPY2(W,C,X,N)
      SAVE
      DIMENSION W(1),X(1)
      DO 100 I=1,N
        W(I) = C * X(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVSUB0(W,X,Y,N)
      SAVE
      DIMENSION W(1),X(1),Y(1)
      DO 100 I=1,N
        W(I) = X(I) - Y(I)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE QVSUB1(W,X,C,N)
      SAVE
      DIMENSION W(1),X(1)
      DO 100 I=1,N
        W(I) = X(I) - C
  100 CONTINUE
      RETURN
      END
